import java.applet.*;
import java.awt.*;
import java.awt.image.*;

/**
 * }bv _mCY2048x2048hbg̃}bv𐶐
 */

public class MapImage extends PixelBuffer32
{
	/** [p[N */
	int workStaticRand1;
	/** [p[N */
	int workStaticRand2;
	public MapImage()
	{
		super(null, 2048, 2048, 0);// ŒlAύXs
		workStaticRand1 = (int)(Math.random()*0x7fffffff);
		CreateNoiseMap();
	}

	/** }bv */
	public void CreateNoiseMap()
	{
		int x, y, n, m;
		int u, v, r1, r2;
		int width1, height1;// ANDl
		int map[][] = new int[width][height];// mCYobt@
		int palette[] = CreatePalette();// J[pbg
		width1 = width-1;
		height1 = height-1;
		// obt@
		for(y=0; y<height; y+=1)for(x=0; x<width; x+=1)map[x][y] = 0;
		map[0][0] = 128;
		// iKmCY
		for(n=width; n>1; n>>=1)
		{
			m = n>>1;
			r2 = n;
			if(r2 > 128)r2 = 128;// L͈͂łA傫mCY͐Ȃ
			r1 = r2*2+1;
			for(y=0; y<height; y+=n)for(x=0; x<width; x+=n)
			{
				// ݒς݂̒l4̒ԒlɃmCY
				u = (x+n) & width1;
				v = (y+n) & height1;
				map[x+m][y] = ((map[x][y] + map[u][y]) >> 1) + randN(r1) - r2;
				map[x+m][v] = ((map[x][v] + map[u][v]) >> 1) + randN(r1) - r2;
				map[x][y+m] = ((map[x][y] + map[x][v]) >> 1) + randN(r1) - r2;
				map[u][y+m] = ((map[u][y] + map[u][v]) >> 1) + randN(r1) - r2;
				map[x+m][y+m] = ((map[x][y] + map[u][y] + map[x][v] + map[u][v]) >> 2) + randN(r1) - r2;
			}
		}
		// őŏl߂0`255܂łɎ߂
		n = 0x7fffffff;
		m = 0x80000000;
		for(y=0; y<height; y+=1)for(x=0; x<width; x+=1)
		{
			u = map[x][y];
			if(n > u)n = u;
			if(m < u)m = u;
		}
		m -= n;
		for(y=0; y<height; y++)for(x=0; x<width; x++)
		{
			map[x][y] = (map[x][y]-n)*255/m;
		}
		// Flɕϊ
		for(y=0; y<height; y++)for(x=0; x<width; x++)
		{
			// pbg̐FlɒPϊ
			u = map[x][y];
			v = palette[u];
			// hbgɑ΂Ãhbg̕ꍇ͉ełƔfÂ
			m = map[x-1&width1][y-1&height1] - u;
			if(m > 0 && u >= 128)
			{
				m = (4-m)*64;
				if(m < 64)m = 64;
				v = (((v & 0xff00ff)*m & 0xff00ff00)>>>8) | (((v & 0x00ff00)*m & 0x00ff0000)>>>8);
			}
			// FlƂĎgpȂ8rbg͍xƂAC:0A:0`127
			px[y*height+x] = v | ((u < 128 ? 0 : u-128)<<24);
		}
	}

	/** RGBlP̐Flɕϊ */
	int CalcPaletteValueRGB(int r, int g, int b)
	{
		if(r<0)r=0; if(r>255)r=255;
		if(g<0)g=0; if(g>255)g=255;
		if(b<0)b=0; if(b>255)b=255;
		return (r<<16) | (g<<8) | b;
	}

	/** FlAlevel0`256ő傫قc0ɋ߂Ȃ */
	int CalcPaletteValueMerge(int c0, int c1, int level)
	{
		int c;
		c  = (((c0 & 0xff00ff)*level & 0xff00ff00)>>>8) | (((c0 & 0x00ff00)*level & 0x00ff0000)>>>8);
		level = 256-level;
		c += (((c1 & 0xff00ff)*level & 0xff00ff00)>>>8) | (((c1 & 0x00ff00)*level & 0x00ff0000)>>>8);
		return c;
	}

	/** J[pbg */
	int[] CreatePalette()
	{
		int palette[] = new int[256];
		int n, m;
		// S
		for(n=0; n<128; n++)
		{
			palette[n] = CalcPaletteValueRGB(0, n-64, n+64);// C̐F
			palette[n+128] = CalcPaletteValueRGB(n*2, 64+n, n);// ̗΁EF
		}
		// Cݐ
		for(n=0; n<8; n++)
		{
			m = 256 - (n<4 ? n+1 : 8-n) * 48;
			palette[128+n-4] = CalcPaletteValueMerge( palette[128+n-4], 0xffffff, m);
		}
		// R
		for(n=192; n<224; n++)
		{
			m = 256 - (n-192)*8;
			palette[n] = CalcPaletteValueMerge( palette[n], 0xffffff, m);
		}
		for(n=224; n<256; n++)palette[n] = 0xffffff;
		return palette;
	}

	/** [ 0`255 */
	public int randB()
	{
		int work;
		work = workStaticRand1;
		workStaticRand1 = workStaticRand1*5+workStaticRand2+0x7654321;
		workStaticRand2 = work;
		return work>>>24;
	}
	/** [ 0`n-1 */
	public int randN(int n)
	{
		return (( (randB())+(randB()<<8)+(randB()<<16)+(randB()<<24) ) & 0x7fffffff) % n;
	}

	/** XN[ɕ\TlC쐬 2048x2048128x128 */
	public PixelBuffer32 createThumb()
	{
		PixelBuffer32 thumb;
		int x, y, u, v, c, r, g, b;
		int w0, h0, s0, s1;
		thumb = new PixelBuffer32(null, 128, 128, 0);
		w0 = width / thumb.width;
		h0 = height / thumb.height;
		s0 = w0 * h0;
		s1 = s0 / 2;
		for(y=0; y<height; y+=h0)for(x=0; x<width; x+=w0)
		{
			r = g = b = 0;
			for(v=0; v<h0; v++)for(u=0; u<w0; u++)
			{
				c = px[(y+v)*width+x+u];
				r += (c>>>16) & 255;
				g += (c>>> 8) & 255;
				b += (c     ) & 255;
			}
			r = (r+s1) / s0;
			g = (g+s1) / s0;
			b = (b+s1) / s0;
			thumb.px[ (y/h0)*thumb.width + (x/w0) ] = (r<<16) | (g<<8) | b;
		}
		return thumb;
	}

	/** `eXgp}bv */
	/*
	public void CreateCuveMap()
	{
		int x, y, u, v, ad, c;
		for(y=0; y<height; y+=32)for(x=0; x<width; x+=32)
		{
			c = randB();
			for(v=0; v<32; v++)
			{
				ad = (y+v)*width+x;
				for(u=0; u<32; u++)
				{
					px[ad] = c | ((c < 128 ? 0 : c-128)<<24);
					ad++;
				}
			}
		}
	}
	*/

	/** `eXgp}bv */
	/*
	public void CreateMulMap()
	{
		int n, m, x, y;
		m = width*height;
		for(n=0; n<m; n++)px[n] = n*n;
		for(y=0; y<256; y++)for(x=0; x<128; x++)px[y*width+x] = x ^ y;
	}
	*/
}

